%   BAT.m

%   This software is protected by german copyright and international treaties.             
%   Copyright 2004 Markus Junghfer & Peter Peyk. All Rights Reserved.                     
%                                                                                          
%   THIS SOFTWARE AND DOCUMENTATION IS PROVIDED "AS IS," AND COPYRIGHT HOLDERS MAKE        
%   NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO,    
%   WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE    
%   OF THE SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE ANY THIRD PARTY PATENTS, COPYRIGHTS,
%   TRADEMARKS OR OTHER RIGHTS. COPYRIGHT HOLDERS WILL NOT BE LIABLE FOR ANY DIRECT,       
%   INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF ANY USE OF THE SOFTWARE      
%   OR DOCUMENTATION. 



%---------------------------------------------------------------
% model(1) Low-Off vs High Off
%---------------------------------------------------------------
clear F1 F2 F3
                                                                     
Mask=['sra*.img'];
FolderName=['D:\fmri\Adjectives\RefSlice2\Attempt2\FS_Adj_04\SPM\Mov0'];
F1=spm_get('Files',FolderName,Mask);
RealignFile1=spm_get('Files',FolderName,['realignment*.*'])
RealignMat1=ReadTxtMat(RealignFile1,[6 132]);
RealignMat1=RealignMat1';
if size(RealignMat1)~=[132 6]
   error('size(RealignMat1)~=[132 6]')
end
FolderName=['D:\fmri\Adjectives\RefSlice2\Attempt2\FS_Adj_04\SPM\Mov1'];
F2=spm_get('Files',FolderName,Mask);
RealignFile2=spm_get('Files',FolderName,['realignment*.*'])
RealignMat2=ReadTxtMat(RealignFile2,[6 132]);
RealignMat2=RealignMat2';
if size(RealignMat2)~=[132 6]
   error('size(RealignMat2)~=[132 6]')
end
FolderName=['D:\fmri\Adjectives\RefSlice2\Attempt2\FS_Adj_04\SPM\Mov2'];
F3=spm_get('Files',FolderName,Mask);
RealignFile3=spm_get('Files',FolderName,['realignment*.*'])
RealignMat3=ReadTxtMat(RealignFile3,[6 132]);
RealignMat3=RealignMat3';
if size(RealignMat3)~=[132 6]
   error('size(RealignMat3)~=[132 6]')
end

F1
F2
F3

%---------------------------------------------------------------
% batch variables defined here for analysis 'model'
%---------------------------------------------------------------

model(1) = struct( ...
 'types',          4, ...
 'global_effects', {'Scaling'}, ...
 'burst_mode',     0, ...
 'HF_fil',         'specify',  ...
 'HF_cut',         [48 48 48], ...
 'LF_fil',         'Gaussian', ...
 'LF_cut',         [4], ...
 'int_corr',       'none', ... 
 'now_later',      1, ...
 'stop_writing',   0, ...
 'trial_fcon',     0, ...
 'RT',             3, ...
 'replicated',     0, ...
 'same_time_param',0, ...
 'nsess',          3, ...
 'nscans',         [132 132 132], ...
 'files',          {{F1 F2 F3}}, ...
 'conditions_nb',  [4 4 4], ...     
 'conditions',     [1 2 3], ...
 'regressors_nb',  [6 6 6], ...
 'regressors',     [1 2 3], ...
 'parametrics_type', {{'none','none','none'}}, ...
 'parametrics',    [], ...
 'stochastics_flag',[0 0 0], ...
 'stochastics',    []);
 
NScanPerBlock=4;
Base=0.5;
% Video beginnt mit PseuAudi bei Volume 5 also sollte Base=1 sein

Vis1=[1 7 9 15 17 23 25 31].*NScanPerBlock+Base
Audi1 =[3 5 11 13 19 21 27 29].*NScanPerBlock+Base
PseuVis1=[2 6 12 16 20 24 26 30].*NScanPerBlock+Base
PseuAudi1 =[4 8 10 14 18 22 28 32].*NScanPerBlock+Base
%-------------------------------------------
conditions(1) = struct( ...
 'names',   {{'Vis1','Audi1','PseuVis1','PseuAudi1'}}, ...
 'onsets',{{Vis1,Audi1,PseuVis1,PseuAudi1}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                   
 'volterra',  0, ...
 'variable_dur',0);
%-------------------------------------------
bf_ep(1) = struct( ...
  'ep_type',4, ...
  'length',NScanPerBlock, ...
  'conv',  1, ...  
  'deriv', 0);
%-------------------------------------------
%-------------------------------------------
Vis2=[3 7 9 13 19 21 27 29].*NScanPerBlock+Base
Audi2 =[1 5 11 15 17 23 24 31].*NScanPerBlock+Base
PseuVis2=[4 6 12 14 18 24 28 30].*NScanPerBlock+Base
PseuAudi2 =[2 8 10 16 20 22 26 32].*NScanPerBlock+Base
%-------------------------------------------
conditions(2) = struct( ...
 'names',   {{'Vis2','Audi2','PseuVis2','PseuAudi2'}}, ...
 'onsets',{{Vis2,Audi2,PseuVis2,PseuAudi2}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                   
 'volterra',  0, ...
 'variable_dur',0);
%-------------------------------------------
bf_ep(1) = struct( ...
  'ep_type',4, ...
  'length',NScanPerBlock, ...
  'conv',  1, ...  
  'deriv', 0);
%-------------------------------------------
%-------------------------------------------
%-------------------------------------------
%-------------------------------------------
Vis3=[2 6 12 16 20 22 26 32].*NScanPerBlock+Base
Audi3 =[4 8 10 14 18 24 28 30].*NScanPerBlock+Base
PseuVis3=[3 5 11 13 19 21 27 29].*NScanPerBlock+Base
PseuAudi3 =[1 7 9 15 17 23 25 31].*NScanPerBlock+Base
%-------------------------------------------
conditions(3) = struct( ...
 'names',   {{'Vis3','Audi3','PseuVis3','PseuAudi3'}}, ...
 'onsets',{{Vis3,Audi3,PseuVis3,PseuAudi3}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                   
 'volterra',  0, ...
 'variable_dur',0);
%-------------------------------------------
bf_ep(1) = struct( ...
  'ep_type',4, ...
  'length',NScanPerBlock, ...
  'conv',  1, ...  
  'deriv', 0);
%-------------------------------------------
%-------------------------------------------

regressors(1) = struct( ...
'names', {{'x1','y1','z1','Pitch1','Roll1','Yaw1'}}, ...
'values',RealignMat1);
regressors(2) = struct( ...
'names', {{'x2','y2','z2','Pitch2','Roll2','Yaw2'}}, ...
'values',RealignMat2);
regressors(3) = struct( ...
'names', {{'x3','y3','z3','Pitch3','Roll3','Yaw3'}}, ...
'values',RealignMat3);

%-------------------------------------------
%-------------11111, 222222 & 333333 = All--
%-------------------------------------------
Vec=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
%-------------------------------------------
Vis1=1;
PseuVis1=-1;
Vis2=1;
PseuVis2=-1;
Vis3=1;
PseuVis3=-1;
CVisBTPseuVisAll=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTPseuVisAll=-CVisBTPseuVisAll;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 

Audi1=1;
PseuAudi1=-1;
Audi2=1;
PseuAudi2=-1;
Audi3=1;
PseuAudi3=-1;
CAudiBTPseuAudiAll=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CAudiLTPseuAudiAll=-CAudiBTPseuAudiAll;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=1;
PseuVis1=-1;
Vis2=1;
PseuVis2=-1;
Vis3=1;
PseuVis3=-1;
Audi1=1;
PseuAudi1=-1;
Audi2=1;
PseuAudi2=-1;
Audi3=1;
PseuAudi3=-1;
CVisAudiBTPseuVisAudiAll=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisAudiLTPseuVisAudiAll=-CVisAudiBTPseuVisAudiAll;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=1;
PseuVis1=-1;
Vis2=1;
PseuVis2=-1;
Vis3=1;
PseuVis3=-1;
Audi1=-1;
PseuAudi1=1;
Audi2=-1;
PseuAudi2=1;
Audi3=-1;
PseuAudi3=1;
CVisBTAudiAll=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTAudiAll=-CVisBTAudiAll;
%-------------------------------------------
%--------------111111---------------------
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=1;
PseuVis1=-1;
CVisBTPseuVis1=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTPseuVis1=-CVisBTPseuVis1;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Audi1=1;
PseuAudi1=-1;
CAudiBTPseuAudi1=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CAudiLTPseuAudi1=-CAudiBTPseuAudi1;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=1;
PseuVis1=-1;
Audi1=1;
PseuAudi1=-1;
CVisAudiBTPseuVisAudi1=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisAudiLTPseuVisAudi1=-CVisAudiBTPseuVisAudi1;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=1;
PseuVis1=-1;
Audi1=-1;
PseuAudi1=1;
CVisBTAudi1=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTAudi1=-CVisBTAudi1;
%-------------------------------------------
%--------------22222222---------------------
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis2=1;
PseuVis2=-1;
CVisBTPseuVis2=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTPseuVis2=-CVisBTPseuVis2;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Audi2=1;
PseuAudi2=-1;
CAudiBTPseuAudi2=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CAudiLTPseuAudi2=-CAudiBTPseuAudi2;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis2=1;
PseuVis2=-1;
Audi2=1;
PseuAudi2=-1;
CVisAudiBTPseuVisAudi2=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisAudiLTPseuVisAudi2=-CVisAudiBTPseuVisAudi2;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis2=1;
PseuVis2=-1;
Audi2=-1;
PseuAudi2=1;
CVisBTAudi2=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTAudi2=-CVisBTAudi2;
%-------------------------------------------
%--------------33333333---------------------
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis3=1;
PseuVis3=-1;
CVisBTPseuVis3=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTPseuVis3=-CVisBTPseuVis3;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Audi3=1;
PseuAudi3=-1;
CAudiBTPseuAudi3=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CAudiLTPseuAudi3=-CAudiBTPseuAudi3;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis3=1;
PseuVis3=-1;
Audi3=1;
PseuAudi3=-1;
CVisAudiBTPseuVisAudi3=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisAudiLTPseuVisAudi3=-CVisAudiBTPseuVisAudi3;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis3=1;
PseuVis3=-1;
Audi3=-1;
PseuAudi3=1;
CVisBTAudi3=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTAudi3=-CVisBTAudi3;
%-------------------------------------------
%----------------Linear------------------
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=-1;
PseuVis1=1;
Vis3=1;
PseuVis3=-1;
CVisBTPseuVisLin=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisLTPseuVisLin=-CVisBTPseuVisLin;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Audi1=-1;
PseuAudi1=1;
Audi3=1;
PseuAudi3=-1;
CAudiBTPseuAudiLin=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CAudiLTPseuAudiLin=-CAudiBTPseuAudiLin;
%-------------------------------------------
Vis1=0; Audi1=0; PseuVis1=0; PseuAudi1=0; Vis2=0; Audi2=0; PseuVis2=0; PseuAudi2=0; Vis3=0; Audi3=0; PseuVis3=0; PseuAudi3=0; 
Vis1=-1;
PseuVis1=1;
Vis3=1;
PseuVis3=-1;
Audi1=-1;
PseuAudi1=1;
Audi3=1;
PseuAudi3=-1;
CVisAudiBTPseuVisAudiLin=[Vis1 Audi1 PseuVis1 PseuAudi1 0 0 0 0 0 0 Vis2 Audi2 PseuVis2 PseuAudi2 0 0 0 0 0 0 Vis3 Audi3 PseuVis3 PseuAudi3 0 0 0 0 0 0 0 0 0]
%-------------------------------------------
CVisAudiLTPseuVisAudiLin=-CVisAudiBTPseuVisAudiLin;

contrasts(1) = struct( ...
'names',  {{...
'CVisBTPseuVisAll','CVisLTPseuVisAll','CAudiBTPseuAudiAll','CAudiLTPseuAudiAll', ...
'CVisAudiBTPseuVisAudiAll','CVisAudiLTPseuVisAudiAll','CVisBTAudiAll','CVisLTAudiAll', ...
'CVisBTPseuVis1','CVisLTPseuVis1','CAudiBTPseuAudi1','CAudiLTPseuAudi1', ...
'CVisAudiBTPseuVisAudi1','CVisAudiLTPseuVisAudi1','CVisBTAudi1','CVisLTAudi1', ...
'CVisBTPseuVis2','CVisLTPseuVis2','CAudiBTPseuAudi2','CAudiLTPseuAudi2', ...
'CVisAudiBTPseuVisAudi2','CVisAudiLTPseuVisAudi2','CVisBTAudi2','CVisLTAudi2', ...
'CVisBTPseuVis3','CVisLTPseuVis3','CAudiBTPseuAudi3','CAudiLTPseuAudi3', ...
'CVisAudiBTPseuVisAudi3','CVisAudiLTPseuVisAudi3','CVisBTAudi3','CVisLTAudi3', ...
'CVisBTPseuVisLin','CVisLTPseuVisLin','CAudiBTPseuAudiLin','CAudiLTPseuAudiLin', ....
'CVisAudiBTPseuVisAudiLin','CVisAudiLTPseuVisAudiLin', ...
}}, ...
'types',   {{ ...
'T','T','T','T','T','T','T','T',...
'T','T','T','T','T','T','T','T',...
'T','T','T','T','T','T','T','T',...
'T','T','T','T','T','T',...
}}, ...
'values',  {{...
CVisBTPseuVisAll,CVisLTPseuVisAll,CAudiBTPseuAudiAll,CAudiLTPseuAudiAll, ...
CVisAudiBTPseuVisAudiAll,CVisAudiLTPseuVisAudiAll,CVisBTAudiAll,CVisLTAudiAll, ...
CVisBTPseuVis1,CVisLTPseuVis1,CAudiBTPseuAudi1,CAudiLTPseuAudi1, ...
CVisAudiBTPseuVisAudi1,CVisAudiLTPseuVisAudi1,CVisBTAudi1,CVisLTAudi1, ...
CVisBTPseuVis2,CVisLTPseuVis2,CAudiBTPseuAudi2,CAudiLTPseuAudi2, ...
CVisAudiBTPseuVisAudi2,CVisAudiLTPseuVisAudi2,CVisBTAudi2,CVisLTAudi2, ...
CVisBTPseuVis3,CVisLTPseuVis3,CAudiBTPseuAudi3,CAudiLTPseuAudi3, ...
CVisAudiBTPseuVisAudi3,CVisAudiLTPseuVisAudi3,CVisBTAudi3,CVisLTAudi3,...
CVisBTPseuVisLin,CVisLTPseuVisLin,CAudiBTPseuAudiLin,CAudiLTPseuAudiLin, ....
CVisAudiBTPseuVisAudiLin,CVisAudiLTPseuVisAudiLin, ...
}} ...
);

