%   BAT.m

%   This software is protected by german copyright and international treaties.             
%   Copyright 2004 Markus Junghfer & Peter Peyk. All Rights Reserved.                     
%                                                                                          
%   THIS SOFTWARE AND DOCUMENTATION IS PROVIDED "AS IS," AND COPYRIGHT HOLDERS MAKE        
%   NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO,    
%   WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE    
%   OF THE SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE ANY THIRD PARTY PATENTS, COPYRIGHTS,
%   TRADEMARKS OR OTHER RIGHTS. COPYRIGHT HOLDERS WILL NOT BE LIABLE FOR ANY DIRECT,       
%   INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF ANY USE OF THE SOFTWARE      
%   OR DOCUMENTATION. 


global SubInd SubIndStr Base BaseStr MaskStr

%---------------------------------------------------------------
% model(1) 
%---------------------------------------------------------------
                                                                     
clear F1 F2 F3 F4
Mask=[MaskStr,'*.img']



FolderName=['G:\JungSchupp\0030JS\0030_',SubIndStr,'\0003\']
F1=spm_get('Files',FolderName,Mask);
Backmask0003RealignFile=spm_get('Files',FolderName,['realignment*.*'])
Backmask0003RealignMat=ReadTxtMat(Backmask0003RealignFile,[6 200]);
Backmask0003RealignMat=Backmask0003RealignMat';
if size(Backmask0003RealignMat)~=[200,6]
   error('size(Backmask0003RealignMat)~=[200,6]')
end


FolderName=['G:\JungSchupp\0030JS\0030_',SubIndStr,'\0004\'];
F2=spm_get('Files',FolderName,Mask);
Backmask0004RealignFile=spm_get('Files',FolderName,['realignment*.*'])
Backmask0004RealignMat=ReadTxtMat(Backmask0004RealignFile,[6 200]);
Backmask0004RealignMat=Backmask0004RealignMat';
if size(Backmask0004RealignMat)~=[200,6]
   error('size(Backmask0004RealignMat)~=[200,6]')
end


FolderName=['G:\JungSchupp\0030JS\0030_',SubIndStr,'\0005\'];
F3=spm_get('Files',FolderName,Mask);
Backmask0005RealignFile=spm_get('Files',FolderName,['realignment*.*'])
Backmask0005RealignMat=ReadTxtMat(Backmask0005RealignFile,[6 200]);
Backmask0005RealignMat=Backmask0005RealignMat';
if size(Backmask0005RealignMat)~=[200,6]
   error('size(Backmask0005RealignMat)~=[200,6]')
end


FolderName=['G:\JungSchupp\0030JS\0030_',SubIndStr,'\0006\'];
F4=spm_get('Files',FolderName,Mask);
Backmask0006RealignFile=spm_get('Files',FolderName,['realignment*.*'])
Backmask0006RealignMat=ReadTxtMat(Backmask0006RealignFile,[6 200]);
Backmask0006RealignMat=Backmask0006RealignMat';
if size(Backmask0006RealignMat)~=[200,6]
   error('size(Backmask0006RealignMat)~=[200,6]')
end


F1
F2
F3
F4

% if SubInd==21 | SubInd==23 | SubInd==24  
%    F1Tmp=F2;
%    F2=F1;
%    F1=F1Tmp;
%    ValAro36RealignMatTmp=ValAro36RealignMat;
%    ValAro09RealignMat=ValAro36RealignMat;
%    ValAro36RealignMat=ValAro36RealignMatTmp;
%    clear F1Tmp ValAro36RealignMatTmp
%    F1
%    F2
% end

%---------------------------------------------------------------
% batch variables defined here for analysis 'model'
%---------------------------------------------------------------

model(1) = struct( ...
 'types',          4, ...
 'global_effects', {'Scaling'}, ...
 'burst_mode',     0, ...
 'HF_fil',         'specify',  ...
 'HF_cut',         [125 125 125 125], ...
 'LF_fil',         'none', ...
 'LF_cut',         [], ...
 'int_corr',       'none', ... 
 'now_later',      1, ...
 'stop_writing',   0, ...
 'trial_fcon',     0, ...
 'RT',             2.6, ...
 'replicated',     0, ...
 'same_time_param',0, ...
 'nsess',          4, ...
 'nscans',         [200 200 200 200], ...
 'files',          {{F1 F2 F3 F4}}, ...
 'conditions_nb',  [4 4 4 4], ...     
 'conditions',     [1 2 3 4], ...
 'regressors_nb',  [6 6 6 6], ...
 'regressors',     [1 2 3 4], ...
 'parametrics_type', {{'none','none','none','none'}}, ...
 'parametrics',    [], ...
 'stochastics_flag',[0 0 0 0], ...
 'stochastics',    []);
 
NScanPerBlock=4.61538461538;
OnsetMat=zeros(4,4,10);
for i=1:4
    if i==1
        SessStr='__0';
    elseif i==2
        SessStr='_11';
    elseif i==3
        SessStr='_33';
    elseif i==4
        SessStr='100';
    end
    for j=1:4
        if j==1
            ConStr='neutpos';
        elseif j==2
            ConStr='neutneg';
        elseif j==3
            ConStr='positive';
        elseif j==4
            ConStr='negative';
        end
        File=['G:\JungSchupp\0030JS\0030logfiles\onsets\onsets_',ConStr,'_',SubIndStr,'backmask',SessStr,'.txt']
        OnsetMat(i,j,:)=ReadTxtMat(File,[1 10]);
    end
end

NeutPos1=squeeze(OnsetMat(1,1,:));
NeutNeg1=squeeze(OnsetMat(1,2,:));
Pos1=squeeze(OnsetMat(1,3,:));
Neg1=squeeze(OnsetMat(1,4,:));

NeutPos2=squeeze(OnsetMat(2,1,:));
NeutNeg2=squeeze(OnsetMat(2,2,:));
Pos2=squeeze(OnsetMat(2,3,:));
Neg2=squeeze(OnsetMat(2,4,:));

NeutPos3=squeeze(OnsetMat(3,1,:));
NeutNeg3=squeeze(OnsetMat(3,2,:));
Pos3=squeeze(OnsetMat(3,3,:));
Neg3=squeeze(OnsetMat(3,4,:));

NeutPos4=squeeze(OnsetMat(4,1,:));
NeutNeg4=squeeze(OnsetMat(4,2,:));
Pos4=squeeze(OnsetMat(4,3,:));
Neg4=squeeze(OnsetMat(4,4,:));

%-------------------------------------------

conditions(1) = struct( ...
 'names',   {{'NeutPos1','NeutNeg1','Positiv1','Negativ1'}}, ...
 'onsets',{{NeutPos1,NeutNeg1,Pos1,Neg1,}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                       
 'volterra',  0, ...
 'variable_dur',0);

conditions(2) = struct( ...
 'names',   {{'NeutPos2','NeutNeg2','Positiv2','Negativ2'}}, ...
 'onsets',{{NeutPos2,NeutNeg2,Pos2,Neg2,}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                       
 'volterra',  0, ...
 'variable_dur',0);

conditions(3) = struct( ...
 'names',   {{'NeutPos3','NeutNeg3','Positiv3','Negativ3'}}, ...
 'onsets',{{NeutPos3,NeutNeg3,Pos3,Neg3,}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ...                                       
 'volterra',  0, ...
 'variable_dur',0);

conditions(4) = struct( ...
 'names',   {{'NeutPos4','NeutNeg4','Positiv4','Negativ4'}}, ...
 'onsets',{{NeutPos4,NeutNeg4,Pos4,Neg4,}}, ...   
 'types',    {{'epochs','epochs','epochs','epochs'}}, ...  
 'bf_ep',   [1 1 1 1], ... % Index fr Basisfunktion-Definition --> siehe unten bf_ep(1)/bf_ep(2)/usw.                                      
 'volterra',  0, ...
 'variable_dur',0);
%-------------------------------------------

bf_ep(1) = struct( ...
  'ep_type',4, ...
  'length',NScanPerBlock, ...
  'conv',  1, ...  
  'deriv', 0);

% bf_ep(2) = struct( ...
%   'ep_type',4, ...
%   'length',NScanPerBlock, ...
%   'conv',  1, ...  
%   'deriv', 0);
% 
% bf_ep(3) = struct( ...
%   'ep_type',4, ...
%   'length',NScanPerBlock, ...
%   'conv',  1, ...  
%   'deriv', 0);
% 
% bf_ep(4) = struct( ...
%   'ep_type',4, ...
%   'length',NScanPerBlock, ...
%   'conv',  1, ...  
%   'deriv', 0);

regressors(1) = struct( ...
 	'names', {{'x0','y0','z0','Pitch0','Roll0','Yaw0'}}, ...
    'values',Backmask0003RealignMat);
 
regressors(2) = struct( ...
 	'names', {{'x11','y11','z11','Pitch11','Roll11','Yaw11'}}, ...
    'values',Backmask0004RealignMat);

regressors(3) = struct( ...
 	'names', {{'x33','y33','z33','Pitch33','Roll33','Yaw33'}}, ...
    'values',Backmask0005RealignMat);

regressors(4) = struct( ...
 	'names', {{'x100','y100','z100','Pitch100','Roll100','Yaw100'}}, ...
    'values',Backmask0006RealignMat);


%-------------------------------------------

%-----------Arousal Complex-----------------

%-------------------------------------------


CAro_g_0               =[-1 -1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_g_11              =[0 0 0 0 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_g_33              =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_g_100             =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 0 0 0 0];

CAro_pos_0             =[-1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_pos_11            =[0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_pos_33            =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_pos_100           =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0];

CAro_neg_0             =[0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_neg_11            =[0 0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_neg_33            =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CAro_neg_100           =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0];


%-------------------------------------------

%-----------Valence Complex-----------------

%-------------------------------------------


CPosGTNeg_0            =[0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosGTNeg_11           =[0 0 0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosGTNeg_33           =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosGTNeg_100          =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0];

CPosLTNeg_0            =[0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosLTNeg_11           =[0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosLTNeg_33           =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CPosLTNeg_100          =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0];


%-------------------------------------------

%-----------Neutral Complex-----------------

%-------------------------------------------


CNeutPosGTNeutNeg_0    =[1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CNeutPosGTNeutNeg_11   =[0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]; 

CNeutPosGTNeutNeg_33   =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]; 

CNeutPosGTNeutNeg_100  =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0]; 

CNeutPosLTNeutNeg_0    =[-1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CNeutPosLTNeutNeg_11   =[0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CNeutPosLTNeutNeg_33   =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

CNeutPosLTNeutNeg_100  =[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0];


%-------------------------------------------

%-------------All---------------------------

%-------------------------------------------


CAro_g_All             =[-1 -1 1 1 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 -1 -1 1 1 0 0 0 0 0 0 0 0 0 0];

CAro_Pos_All           =[-1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0 0];

CAro_Neg_All           =[0 -1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 -1 0 1 0 0 0 0 0 0 0 0 0 0];

CNeutPosGTNeutNeg_All  =[1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0 0 0];

CNeutPosLTNeutNeg_All  =[-1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0 0 0];

CPosGTNeg_All          =[0 0 1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 1 -1 0 0 0 0 0 0 0 0 0 0];

CPosLTNeg_All          =[0 0 -1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 -1 1 0 0 0 0 0 0 0 0 0 0];


%------------------------------------------------

%-------------Increase---------------------------

%------------------------------------------------


CIncrease_lin_Aro_g_1  =[0 0 1 1 0 0 0 0 0 0 0 0 2 2 0 0 0 0 0 0 0 0 3 3 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_Aro_g_2  =[0 0 -1.5 -1.5 0 0 0 0 0 0 0 0 -0.5 -0.5 0 0 0 0 0 0 0 0 0.5 0.5 0 0 0 0 0 0 0 0 1.5 1.5 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_Aro_pos  =[0 0 1 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_Aro_neg  =[0 0 0 1 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_Neut_g   =[1 1 0 0 0 0 0 0 0 0 2 2 0 0 0 0 0 0 0 0 3 3 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_NeutPos   =[1 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_NeutNeg  =[0 1 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_Aro_g	   =[0 0 1 1 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 9 9 0 0 0 0 0 0 0 0 16 16 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_Aro_pos  =[0 0 1 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 16 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_Aro_neg  =[0 0 0 1 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 16 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_Neut_g   =[1 1 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 9 9 0 0 0 0 0 0 0 0 16 16 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_NeutPos   =[1 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_exp_NeutNeg  =[0 1 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 16 0 0 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_PosGTNeg =[0 0 1 -1 0 0 0 0 0 0 0 0 2 -2 0 0 0 0 0 0 0 0 3 -3 0 0 0 0 0 0 0 0 4 -4 0 0 0 0 0 0 0 0 0 0];

CIncrease_lin_PosLTNeg =[0 0 -1 1 0 0 0 0 0 0 0 0 -2 2 0 0 0 0 0 0 0 0 -3 3 0 0 0 0 0 0 0 0 -4 4 0 0 0 0 0 0 0 0 0 0];


%------------------------------------------------

%-------------Decrease---------------------------

%------------------------------------------------


CDecrease_lin_Aro_g	   =[0 0 4 4 0 0 0 0 0 0 0 0 3 3 0 0 0 0 0 0 0 0 2 2 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0];

CDecrease_lin_Aro_pos  =[0 0 4 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_lin_Aro_neg  =[0 0 0 4 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0];

CDecrease_lin_Neut_g   =[4 4 0 0 0 0 0 0 0 0 3 3 0 0 0 0 0 0 0 0 2 2 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_lin_NeutPos   =[4 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_lin_NeutNeg  =[0 4 0 0 0 0 0 0 0 0 0 3 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_Aro_g	   =[0 0 16 16 0 0 0 0 0 0 0 0 9 9 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_Aro_pos  =[0 0 16 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_Aro_neg  =[0 0 0 16 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_Neut_g   =[16 16 0 0 0 0 0 0 0 0 9 9 0 0 0 0 0 0 0 0 4 4 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_NeutPos   =[16 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0];

CDecrease_exp_NeutNeg  =[0 16 0 0 0 0 0 0 0 0 0 9 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0];







contrasts(1) = struct( ...
    'names',  {{...
            
        'CAro_g_0', ...
        'CAro_g_11', ...
        'CAro_g_33', ...
        'CAro_g_100', ...
        'CAro_pos_0', ...
        'CAro_pos_11', ...
        'CAro_pos_33', ...
        'CAro_pos_100',...
        'CAro_neg_0',...
        'CAro_neg_11',...
        'CAro_neg_33',...
        'CAro_neg_100',...
        'CPosGTNeg_0',...
        'CPosGTNeg_11',...
        'CPosGTNeg_33',...
        'CPosGTNeg_100',...
        'CPosLTNeg_0',...
        'CPosLTNeg_11',...
        'CPosLTNeg_33',...
        'CPosLTNeg_100',...
        'CNeutPosGTNeutNeg_0',...
        'CNeutPosGTNeutNeg_11',...
        'CNeutPosGTNeutNeg_33',...
        'CNeutPosGTNeutNeg_100',...
        'CNeutPosLTNeutNeg_0',...
        'CNeutPosLTNeutNeg_11',...
        'CNeutPosLTNeutNeg_33',...
        'CNeutPosLTNeutNeg_100',...
        'CAro_g_All',...
        'CAro_Pos_All',...
        'CAro_Neg_All',...
        'CNeutPosGTNeutNeg_All',...
        'CNeutPosLTNeutNeg_All',...
        'CPosGTNeg_All',...
        'CPosLTNeg_All',...
        'CIncrease_lin_Aro_g_1',...
        'CIncrease_lin_Aro_g_2',...
        'CIncrease_lin_Aro_pos',...
        'CIncrease_lin_Aro_neg',...
        'CIncrease_lin_Neut_g',...
        'CIncrease_lin_NeutPos',...
        'CIncrease_lin_NeutNeg',...
        'CIncrease_exp_Aro_g',...
        'CIncrease_exp_Aro_pos',...
        'CIncrease_exp_Aro_neg',...
        'CIncrease_exp_Neut_g',...
        'CIncrease_exp_NeutPos',...
        'CIncrease_exp_NeutNeg',...
        'CIncrease_lin_PosGTNeg',...
        'CIncrease_lin_PosLTNeg',...
        'CDecrease_lin_Aro_g',...
        'CDecrease_lin_Aro_pos',...
        'CDecrease_lin_Aro_neg',...
        'CDecrease_lin_Neut_g',...
        'CDecrease_lin_NeutPos',...
        'CDecrease_lin_NeutNeg',...
        'CDecrease_exp_Aro_g',...
        'CDecrease_exp_Aro_pos',...
        'CDecrease_exp_Aro_neg',...
        'CDecrease_exp_Neut_g',...
        'CDecrease_exp_NeutPos,',...
        'CDecrease_exp_NeutNeg',...
            }}, ...
  'types',   {{'T','T','T','T','T','T','T','T','T','T',...
               'T','T','T','T','T','T','T','T','T','T',...
               'T','T','T','T','T','T','T','T','T','T',...
               'T','T','T','T','T','T','T','T','T','T',...
               'T','T','T','T','T','T','T','T','T','T',...
               'T','T','T','T','T','T','T','T','T','T',...
               'T','T',...
            }}, ...
  'values',  {{...
      CAro_g_0,...
      CAro_g_11,...
      CAro_g_33,...
      CAro_g_100,...
      CAro_pos_0,...
      CAro_pos_11,...
      CAro_pos_33,...
      CAro_pos_100,...
      CAro_neg_0,...
      CAro_neg_11,...
      CAro_neg_33,...
      CAro_neg_100,...
      CPosGTNeg_0,...
      CPosGTNeg_11,...
      CPosGTNeg_33,...
      CPosGTNeg_100,...
      CPosLTNeg_0,...
      CPosLTNeg_11,...
      CPosLTNeg_33,...
      CPosLTNeg_100,...
      CNeutPosGTNeutNeg_0,...
      CNeutPosGTNeutNeg_11,...
      CNeutPosGTNeutNeg_33,...
      CNeutPosGTNeutNeg_100,...
      CNeutPosLTNeutNeg_0,...
      CNeutPosLTNeutNeg_11,...
      CNeutPosLTNeutNeg_33,...
      CNeutPosLTNeutNeg_100,...
      CAro_g_All,...
      CAro_Pos_All,...
      CAro_Neg_All,...
      CNeutPosGTNeutNeg_All,...
      CNeutPosLTNeutNeg_All,...
      CPosGTNeg_All,...
      CPosLTNeg_All,...
      CIncrease_lin_Aro_g_1,...
      CIncrease_lin_Aro_g_2,...
      CIncrease_lin_Aro_pos,...
      CIncrease_lin_Aro_neg,...
      CIncrease_lin_Neut_g,...
      CIncrease_lin_NeutPos,...
      CIncrease_lin_NeutNeg,...
      CIncrease_exp_Aro_g,...
      CIncrease_exp_Aro_pos,...
      CIncrease_exp_Aro_neg,...
      CIncrease_exp_Neut_g,...
      CIncrease_exp_NeutPos,...
      CIncrease_exp_NeutNeg,...
      CIncrease_lin_PosGTNeg,...
      CIncrease_lin_PosLTNeg,...
      CDecrease_lin_Aro_g,...
      CDecrease_lin_Aro_pos,...
      CDecrease_lin_Aro_neg,...
      CDecrease_lin_Neut_g,...
      CDecrease_lin_NeutPos,...
      CDecrease_lin_NeutNeg,...
      CDecrease_exp_Aro_g,...
      CDecrease_exp_Aro_pos,...
      CDecrease_exp_Aro_neg,...
      CDecrease_exp_Neut_g,...
      CDecrease_exp_NeutPos,...
      CDecrease_exp_NeutNeg,...
       }} ...
   );
         