%  

%   This software is protected by german copyright and international treaties.             
%   Copyright 2004 Markus Junghfer & Peter Peyk. All Rights Reserved.                     
%                                                                                          
%   THIS SOFTWARE AND DOCUMENTATION IS PROVIDED "AS IS," AND COPYRIGHT HOLDERS MAKE        
%   NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO,    
%   WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE    
%   OF THE SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE ANY THIRD PARTY PATENTS, COPYRIGHTS,
%   TRADEMARKS OR OTHER RIGHTS. COPYRIGHT HOLDERS WILL NOT BE LIABLE FOR ANY DIRECT,       
%   INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF ANY USE OF THE SOFTWARE      
%   OR DOCUMENTATION. 


schaubild = figure('Name','Selectitems', 
    'Units','normalized',
    'Menubar','figure',
	'Position',[0.1328    0.0313    0.5430    0.64 ], 
    'Color',[0.831 0.815 0.784],
	'Tag','schaubild',
    'NumberTitle','off');
                                                                     

schaubildaxes = axes('Position',[0.1 0.1 0.78 0.7],...
    'Units','normalized',...
    'parent',schaubild);

AXIS([0 1 0 1])

xachsenlabel = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.05   0.94   0.02   0.03], ...
	'String','X:', ...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Style','text',...
    'Enable','on',...
	'Tag','xachsenlabel');

xachsenpopup = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.091   0.95    0.23    0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String',['x-achse';'x-achse'], ...
    'Style','popupmenu',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','',...
	'Tag','xachsenpopup');

gruppenradio = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
	'Position',[0.05   0.84    0.23    0.03], ...
	'String','Gruppierungsvariable:', ...
    'Style','radio',...
    'Enable','on',...
    'Callback','enablegruppenpopup;',...
	'Tag','gruppenradio');

gruppenpopup = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.371   0.84    0.23    0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String','Gruppe', ...
    'Style','popupmenu',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','off',...
    'Callback','',...
	'Tag','gruppenpopup');

ttestbutton = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.281   0.84    0.07    0.03], ...
	'String','t-test', ...
    'Style','pushbutton',...
    'Enable','off',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','ttestforgroups(paramat)',...
	'Tag','ttestbutton');


formatlabel = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.54 0.08 0.03], ...
	'String','Mean as:', ...
    'Style','text',...
    'Enable','on',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'HorizontalAlignment','left',...
    'Callback','enablegruppenpopup;',...
	'Tag','formatlabel');

formatpopup = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.5 0.08 0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String',['Punkt';'Bar  '],...
    'Style','popupmenu',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','',...
	'Tag','formatpopup');


farblabel = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.44 0.08 0.03], ...
	'String','Farbe:', ...
    'Style','text',...
    'HorizontalAlignment','left',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','enablegruppenpopup;',...
	'Tag','formatlabel');

farbpopup = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.4 0.08 0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String',['rot ';'grn';'blau';'gelb'],...
    'Style','popupmenu',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','',...
	'Tag','formatpopup');

rotate3dradio = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.24 0.08 0.03], ...
	'String','rotate',...
    'Style','pushbutton',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','rotate3d;',...
	'Tag','rotate3dradio');

griddradio = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.9 0.3 0.08 0.03], ...
	'String','grid',...
    'Style','pushbutton',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','on',...
    'Callback','grid;',...
	'Tag','rotate3dradio');

yachsenlabel = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.33   0.94   0.03    0.03], ...
	'String','Y:', ...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Style','text',...
    'Enable','on',...
	'Tag','yachsenlabel');

yachsenpopup = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.371   0.95   0.23    0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String','y-achse', ...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Style','popupmenu',...
    'Enable','off',...
    'Callback','',...
	'Tag','yachsenpopup');

zachsenradio = uicontrol('Parent',schaubild, ...
    'Units','normalized',...
	'Position',[0.63   0.945   0.1    0.03], ...
	'String','Z:', ...
    'Style','radio',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','toggle3d;',...
    'Enable','on',...
	'Tag','yachsenlabel');

zachsenpopup = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.701   0.95   0.13    0.03], ...
    'BackgroundColor',[1 1 1], ...
	'String','z-achse', ...
    'Style','popupmenu',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Enable','off',...
    'Callback','',...
	'Tag','zachsenpopup');

drawbutton = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.90   0.84    0.08    0.15], ...
	'String','draw', ...
    'FontUnits','normalized',...
    'FontSize',0.1,...
    'Style','pushbutton',...
    'Enable','off',...
    'Callback','seldraw;',...
	'Tag','drawbutton');

dateinamenradio = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.05   0.89    0.23    0.03], ...
	'String','Dateinamen anzeigen', ...
    'Style','radiobutton',...
    'Enable','on',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','',...
	'Tag','dateinamenradio');

zellgrenzenradio = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.371   0.89    0.23    0.03], ...
	'String','Zellgrenzen anzeigen', ...
    'Style','radiobutton',...
    'Enable','on',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','',...
	'Tag','zellgrenzenradio');

gruppenmittelwerteradio = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.63   0.89   0.25    0.03], ...
	'String','Gruppenmittelwerte anzeigen', ...
    'Style','radiobutton',...
    'Enable','on',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','',...
	'Tag','gruppenmittelwerteradio');

gruppenfarbenradio = uicontrol('Parent',schaubild, ...
	'Units','normalized', ...
	'Position',[0.63   0.84    0.25    0.03], ...
	'String','Gruppenfarben anzeigen', ...
    'Style','radiobutton',...
    'Enable','on',...
    'FontUnits','normalized',...
    'FontSize',0.8,...
    'Callback','enablegruppenfarben',...
	'Tag','gruppenfarbenradio');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
